import com.motorola.io.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.Enumeration;

class Lib_mfs{
public static String get_dirs(String path) {
	StringBuffer s = new StringBuffer();
	try{
		FileConnection fs = (FileConnection)Connector.open("file://"+path);
		String[] r = fs.list();
		fs.close();
		for(int i=0;i<r.length;i++) {
			fs = (FileConnection)Connector.open("file://"+path+r[i]);
			if(fs.isDirectory())
				s.append(r[i]).append('|');
			fs.close();
		}
	}catch(Exception e) {return "";}
	return s.toString();		
}
public static String get_files(String path) {
	StringBuffer s = new StringBuffer();
	try{
		FileConnection fs = (FileConnection)Connector.open("file://"+path);
		String[] r = fs.list();
		fs.close();
		for(int i=0;i<r.length;i++) {
			fs = (FileConnection)Connector.open("file://"+path+r[i]);
			if(!fs.isDirectory())
				s.append(r[i]).append('|');
			fs.close();
		}
	}catch(Exception e) {return "";}
	return s.toString();		
}
public static String read_file(String name) {
	StringBuffer s = new StringBuffer();
	try{
		FileConnection fs = (FileConnection)Connector.open("file://"+name);
		int sz = (int)fs.fileSize();
		byte[] d = new byte[sz];
		DataInputStream is = fs.openDataInputStream();
		is.read(d, 0, sz);
		for(int i=0;i<sz;i++){
			byte b= d[i]; 
			s.append((char)(b < 0 ? b == -88 ? 0x401 : b == -72 ? 0x451 : (0x400 | ((b & 0x7f) - 0x30)) : b));
		}
	}catch(Exception e) {return "";}
	return s.toString();
}

public static void write_file(String name, String info) {
	try{
		FileConnection fs = (FileConnection)Connector.open("file://"+name);
		if (!fs.exists())fs.create();
		DataOutputStream os = fs.openDataOutputStream();
		byte[] d = new byte[info.length()];
		for(int i=0;i<d.length;i++){
			char b =  info.charAt(i);
			if(b>255)
				d[i] = (byte)(b-848);
			else
				d[i] = (byte)b;
		}
		os.write(d,0,d.length);
		os.flush();
		os.close();
	}catch(Exception e) {return;}
}

public static void delete_file(String name) {
	try{
		FileConnection fs = (FileConnection)Connector.open("file://"+name);
		fs.delete();	
	}catch(Exception e) {return;}
}

public static int file_exists(String name) {
	try{
		FileConnection fs = (FileConnection)Connector.open("file://"+name);
		if(fs.exists()) return 1;	
	}catch(Exception e) {return 0;}
	return 0;
}

public static int open_file(String name) {
	try{
		fc = (FileConnection) Connector.open("file://"+name);
	}catch(IOException ex) {return -1;}
	return 1;
}

public static int read_byte() throws IOException{
	if(dis==null)
		dis = fc.openDataInputStream();
	return dis.read();
}

public static String read_string() throws IOException{
	if(dis==null)
		dis = fc.openDataInputStream();
	StringBuffer r = new StringBuffer();
	int ch = 0;
	while((ch=dis.read())!='\n'){
		r.append((char)ch);
	}
	return r.toString();
}

public static int close_file() {
	try{
		if(dis!=null) dis.close();
		if(dos!=null) {
			dos.flush();
			dos.close();
		}
		fc.close();
	}catch(IOException ex) {return -1;}
	return 1;
}

public static void rename_file(String source, String dest) {
	try{
		FileConnection fc = (FileConnection) Connector.open("file://"+source);
		fc.rename("file://"+dest);
		fc.close();
	}catch(IOException ex) {}
}

public static String get_roots() {
	StringBuffer s = new StringBuffer();
	try{
		String[] r  = FileSystemRegistry.listRoots();
		for(int i=0;i<r.length;i++)
			s.append(r[i]).append('|');
	}catch(Exception e) {return "";}
	return s.toString();
}

private static FileConnection fc = null;
private static DataInputStream dis = null;
private static DataOutputStream dos = null;
}