import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;
import java.io.InputStream;
import java.io.OutputStream;

class Lib_socket {

  /**
   *  
   * @param url String     socket://server.com[:]
   * @return int  0  ,  -1
   */
  public static int open(String url) {
    try{
      c = (SocketConnection) Connector.open(url);
      i = c.openInputStream();
      o = c.openOutputStream();
    }catch(Exception ex) {return -1;}
    return 0;
  }

  /**
   *  
   */
  public static void close() {
    try{
      if(i != null) {
        i.close();
        i = null;
      }
      if(o != null) {
        o.flush();
        o.close();
        o = null;
      }
      c.close();
      c = null;
    }catch(Exception ex) {c = null;}
  }

  /**
   *      
   * @return int
   */
  public static int available() {
    if(i != null)
      try{
        return i.available();
      }catch(Exception ex) {}
    return 0;
  }

  /**
   *     
   * @return int
   */
  public static int read() {
    try{
      return i.read();
    }catch(Exception ex) {}
    return -1;
  }

  /**
   *    ,        
   * @return InputStream
   */
  public static InputStream get_stream() {
    return i;
  }

  public static int write(int value) {
    try{
      o.write(value);
      return 0;
    }catch(Exception ex) {return -1;}
  }

  private static SocketConnection c;
  private static InputStream i;
  private static OutputStream o;
}
